#include <stdint.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/syscall.h>
uint64_t start, stop;
const char *hello="Hello World!\n";
__inline__ uint64_t rdtsc() 
{
	uint64_t x;
	__asm__ volatile ("rdtsc\n\t" : "=A" (x));
	return x;
}

uint64_t passo1() 
{
	start = rdtsc();
	printf("%s", hello);
	stop = rdtsc();
	return stop - start;
}

uint64_t passo2() 
{
	start = rdtsc();
	write(1,hello,13);
	stop = rdtsc();
	return stop - start;
}

uint64_t passo3() 
{
	start = rdtsc();
	syscall(SYS_write, 1, hello, 13);
	stop = rdtsc();
	return stop - start;
}

uint64_t passo4() 
{
	start = rdtsc();
	__asm__ (
		"movl $0xd, %edx\n\t"
		"movl hello, %ecx\n\t"
		"movl $0x1, %ebx\n\t"
		"movl $0x4, %eax\n\t"
		"int $0x80\n"
	);
	stop = rdtsc();
	return stop - start;
}

__asm__ (
	"append_passo5:\n\t"
	"pushl	%ecx\n\t"
	"pushl	%edx\n\t"
	"pushl	%ebp\n\t"
	"movl	%esp,%ebp\n\t"
	"sysenter\n\t"
);

uint64_t passo5() 
{
	start = rdtsc();
	__asm__ (
		"movl $0xd, %edx\n\t"
		"movl hello, %ecx\n\t"
		"movl $0x1, %ebx\n\t"
		"movl $0x4, %eax\n\t"
		"call append_passo5\n\t"
	);
	stop = rdtsc();
	return stop - start;
}

uint64_t passo6() 
{
	start = rdtsc();
	__asm__ (
		"movl $0xd, %edx\n\t"
		"movl hello, %ecx\n\t"
		"movl $0x1, %ebx\n\t"
		"movl $0x4, %eax\n\t"
		"call *%gs:0x10\n"
	);
	stop = rdtsc();
	return stop - start;
}

int main(int argc, char *argv[]) 
{
	uint64_t diff1, diff2, diff3, diff4, diff5, diff6;
	diff1 = passo1();
	printf("Passo1 -> cicle's clock = %llu\n", diff1);
	diff2 = passo2();
	printf("Passo2 -> cicle's clock = %llu\n", diff2);
	diff3 = passo3();
	printf("Passo3 -> cicle's clock = %llu\n", diff3);
	diff4 = passo4();
	printf("Passo4 -> cicle's clock = %llu\n", diff4);
	diff5 = passo5();
	printf("Passo5 -> cicle's clock = %llu\n", diff5);
	diff6 = passo6();
	printf("Passo6 -> cicle's clock = %llu\n", diff6);
	return 0;
}
